package cn.com.infosec.jce.spec;

import cn.com.infosec.math.ec.ECCurve;
import java.math.BigInteger;
import java.security.spec.ECFieldF2m;
import java.security.spec.ECFieldFp;
import java.security.spec.ECPoint;
import java.security.spec.EllipticCurve;

public class ECNamedCurveSpec extends java.security.spec.ECParameterSpec {
   private String name;

   private static EllipticCurve convertCurve(ECCurve curve, byte[] seed) {
      ECCurve var10003;
      BigInteger curve1;
      if (curve instanceof ECCurve.Fp) {
         ECFieldFp var6;
         ECFieldFp var7 = var6 = new ECFieldFp;
         var10003 = curve;
         var6.<init>(((ECCurve.Fp)curve).getQ());
         curve1 = curve.getA().toBigInteger();
         return new EllipticCurve(var7, curve1, var10003.getB().toBigInteger(), seed);
      } else {
         ECCurve.F2m var2;
         ECFieldF2m var10002;
         int[] var3;
         ECFieldF2m var4;
         if ((var2 = (ECCurve.F2m)curve).isTrinomial()) {
            (var3 = new int[1])[0] = var2.getK1();
            var10002 = var4 = new ECFieldF2m;
            var10003 = curve;
            var4.<init>(var2.getM(), var3);
            curve1 = curve.getA().toBigInteger();
            return new EllipticCurve(var10002, curve1, var10003.getB().toBigInteger(), seed);
         } else {
            int[] var10000 = var3 = new int[3];
            var3[0] = var2.getK3();
            var3[1] = var2.getK2();
            var10000[2] = var2.getK1();
            var10002 = var4 = new ECFieldF2m;
            var10003 = curve;
            var4.<init>(var2.getM(), var3);
            curve1 = curve.getA().toBigInteger();
            return new EllipticCurve(var10002, curve1, var10003.getB().toBigInteger(), seed);
         }
      }
   }

   private static ECPoint convertPoint(cn.com.infosec.math.ec.ECPoint g) {
      return new ECPoint(g.getX().toBigInteger(), g.getY().toBigInteger());
   }

   public ECNamedCurveSpec(String name, ECCurve curve, cn.com.infosec.math.ec.ECPoint g, BigInteger n) {
      ECNamedCurveSpec var10000 = this;
      ECNamedCurveSpec var10001 = this;
      EllipticCurve var5 = convertCurve(curve, (byte[])null);
      var10001.<init>(var5, convertPoint(g), n, 1);
      var10000.name = name;
   }

   public ECNamedCurveSpec(String name, EllipticCurve curve, ECPoint g, BigInteger n) {
      super(curve, g, n, 1);
      this.name = name;
   }

   public ECNamedCurveSpec(String name, ECCurve curve, cn.com.infosec.math.ec.ECPoint g, BigInteger n, BigInteger h) {
      ECNamedCurveSpec var10000 = this;
      ECNamedCurveSpec var10001 = this;
      EllipticCurve var6 = convertCurve(curve, (byte[])null);
      ECPoint curve1 = convertPoint(g);
      int g1 = h.intValue();
      var10001.<init>(var6, curve1, n, g1);
      var10000.name = name;
   }

   public ECNamedCurveSpec(String name, EllipticCurve curve, ECPoint g, BigInteger n, BigInteger h) {
      ECNamedCurveSpec var10000 = this;
      ECNamedCurveSpec var10001 = this;
      int var6 = h.intValue();
      var10001.<init>(curve, g, n, var6);
      var10000.name = name;
   }

   public ECNamedCurveSpec(String name, ECCurve curve, cn.com.infosec.math.ec.ECPoint g, BigInteger n, BigInteger h, byte[] seed) {
      ECNamedCurveSpec var10000 = this;
      ECNamedCurveSpec var10001 = this;
      EllipticCurve var7 = convertCurve(curve, seed);
      ECPoint curve1 = convertPoint(g);
      int g1 = h.intValue();
      var10001.<init>(var7, curve1, n, g1);
      var10000.name = name;
   }

   public String getName() {
      return this.name;
   }
}
